#include "Defines.h"

#define MAXROWS 4
#define MAXCOLUMNS 4
#define ELEMENTFORMAT "%.2f"

#ifndef MATRICE
#define MATRICE

typedef double ELEMENT;
typedef ELEMENT Matrice[MAXROWS][MAXCOLUMNS];
typedef struct DynMatrixStruct
{
    ELEMENT* matrix;
    int rows, cols;
} *DynMatrix;

#endif

CODICEUSCITA readMatrice(Matrice m, int righe, int colonne);
void printMatrice(Matrice m, int righe, int colonne);

void trasposta(Matrice m, Matrice tm, int dim);
void estraiMinore(Matrice minore, Matrice m, int dim, int rigaElemento, int colonnaElemento);
ELEMENT determinante(Matrice m, int dim);

void triang(Matrice a, int rows, int columns);
void elim_indietro(double *x, Matrice a, int rows);

void testDeterminante();
void testGauss();


DynMatrix newDynMatrix(int rows, int cols);
void destroyDynMatrix(DynMatrix m);
BOOLEAN checkBounds(DynMatrix m, int row, int col);
ELEMENT getMatrixElement(DynMatrix m, int row, int col);
void setMatrixElement(DynMatrix m, int row, int col, ELEMENT value);
int getRowCount(DynMatrix m);
int getColCount(DynMatrix m);

DynMatrix estraiMinore_dyn(DynMatrix m, int elRow, int elColumn);
ELEMENT determinante_dyn(DynMatrix m);
void printMatrice_dyn(DynMatrix m);

void testDeterminante_dyn();
